package bug;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.Enumeration;
import java.util.jar.Attributes;
import java.util.jar.Manifest;

public class Versions
{
	public static void versions() throws Exception {		
		ClassLoader sysloader = ClassLoader.getSystemClassLoader();
		// java 3d
		String j3dVersion = null;
		Enumeration manifests = sysloader.getResources("META-INF/MANIFEST.MF");
		while (manifests.hasMoreElements()) {
			URL jar = (URL)manifests.nextElement();
			Manifest manifest = new Manifest(jar.openConnection().getInputStream());
			Attributes attributes =manifest.getMainAttributes();
			String name = attributes.getValue("Extension-Name");
			if (name != null && name.equals("javax.media.j3d"))
			{
				j3dVersion = attributes.getValue("Implementation-Version"); 
				break; // first
			}
		}
		// visad
		String visadVersion = null;
		manifests = sysloader.getResources("DATE");
		while (manifests.hasMoreElements()) {
			URL jar = (URL)manifests.nextElement();
			BufferedReader in = new BufferedReader(new InputStreamReader(jar.openStream()));
			visadVersion = in.readLine();
			in.close();
		}
		System.err.println("Java Version: " + System.getProperty("java.version"));
		System.err.println("Java3D Version: " + j3dVersion);
		System.err.println("VISAD Version: " + visadVersion);
	}
}
